/*****************************************************************************
 *   Project:     GENETIC5.PRJ                                                *
 *****************************************************************************
 *   Modules:     GENPARM5.H                                                 *
 *                EXTERN5.H                                                  *
 *                INTERN5.H                                                  *
 *                GENETIC5.C                                                 *
 *                POPUL5.C                                                   *
 *                EVAL5.C                                                    *
 *                DISPLAY5.C                                                 *
 *                REPRO5.C                                                   *
 *****************************************************************************
 *   Topic:       EXTERN5.H                                                   *
 *****************************************************************************
 *   Description: This module contains all external variables, structures,   *
 *                type definitions and parameters to control the GA.         *
 *****************************************************************************/
#include "genparm5.h"

extern SORT_STRUCT sort_array[POP_SIZE];               /* array that contains individuums sorted by fitness in decreasing order */

extern GENERATION akt_generation;                      /* current generation */
extern CHROMOSOME very_best_ind;                       /* best individuum overall */
extern FITNESS_GRAPH fitness_chart[TRIALS/POP_SIZE];   /* array containing fitnesses of all generations */

extern char str_fitness[80],                           /* name of fitness type */
            str_selection[80];                         /* name of parent selection type */
