/*****************************************************************************
 *   Project:     GENETIC5.PRJ                                               *
 *****************************************************************************
 *   Modules:     GENPARM5.H                                                 *
 *                EXTERN5.H                                                  *
 *                INTERN5.H                                                  *
 *                GENETIC5.C                                                 *
 *                POPUL5.C                                                   *
 *                EVAL5.C                                                    *
 *                DISPLAY5.C                                                 *
 *                REPRO5.C                                                   *
 *****************************************************************************
 *   Topic:       INTERN5.H                                                  *
 *****************************************************************************
 *   Description: This module contains all global variables, structures,     *
 *                type definitions and parameters to control the GA.         *
 *****************************************************************************/
#include "genparm5.h"

SORT_STRUCT sort_array[POP_SIZE];              /* array that contains individuums sorted by fitness in decreasing order */

GENERATION akt_generation;                     /* current generation */
CHROMOSOME very_best_ind;                      /* best individuum overall */
FITNESS_GRAPH fitness_chart[TRIALS/POP_SIZE];  /* array containing fitnesses of all generations */

char str_fitness[80],                          /* name of fitness type */
     str_selection[80];                        /* name of parent selection type */

extern unsigned _stklen = 16384;             /* increase stack size for quicksort-algorithm */
