/*  */
/* (c) 1991 by Expert Informatik 					 */
/* All rights reserved							 */
/*  */
/* Filename   : GENLIB.H                                                 */
/* Author     : Sven Feddersen						 */
/* Project    : GenLib     						 */
/*  */
/*									 */
/* Comment :								 */
/*                                                                       */
/*   Include-Datei fr die GENLIB-Bibliothek                             */
/*									 */
/*  */

#ifndef _GENLIB_H_
#define _GENLIB_H_

#ifndef TRUE
#define TRUE	!0
#endif

#ifndef FALSE
#define FALSE	0
#endif

#ifndef boolean
#define boolean unsigned int
#endif

#define SWAP(x1, x2) { x1 ^= x2; x2 ^= x1; x1 ^= x2; }

#define FILTER_TWINS       TRUE
#define DONT_FILTER_TWINS  FALSE

#define USE_RATE           TRUE
#define USE_STEP           FALSE

#define GLE_NO_MEMORY     1
#define GLE_WRONG_JOBSIZE 2

typedef struct {
  void    *myrep;
  unsigned myGeneration;
  double   mutprob;
  double   mutdim;
  double   fitness;
} CHROM;

typedef struct {
  unsigned size;
  double fitsum;
  double invfitsum;
  unsigned *fitvec;
  CHROM *rep;
} POPULATION;

typedef double   (*GLT_EvalType)(CHROM*);
typedef int      (*GLT_ControlType)(unsigned, POPULATION*);
typedef int      (*GLT_CrossoverType)(CHROM*, CHROM*, CHROM*);
typedef int      (*GLT_MutationType)(CHROM*);
typedef unsigned (*GLT_SelectionType)(POPULATION*);

typedef int      (*GLT_AllocType)(unsigned, POPULATION *);
typedef int      (*GLT_InitType)(POPULATION *);
typedef void     (*GLT_CopyType)(CHROM *, CHROM *);
typedef int      (*GLT_FreeType)(POPULATION *);

double        EqualRandom(void);
double        EqualDoubleRandom(double d);
int           EqualUnsignedRandom(unsigned u);
unsigned long EqualLongRandom(unsigned long l);
int           EqualRandomIntVec(unsigned *vec, unsigned n, unsigned mx);
double        NormalRandom(void);
double        NormalDoubleRandom(double d);
int           NormalUnsignedRandom(unsigned u);
unsigned long NormalLongRandom(unsigned long l);

unsigned InvRouletteSelection(POPULATION *pop);
unsigned GaussSelection(POPULATION *pop);

int evolution(unsigned popsize, unsigned hold,
	      boolean filtertwins, GLT_SelectionType select,
	      GLT_CrossoverType cross, double mutrate, double mutdim,
	      GLT_MutationType mute, GLT_EvalType evalfun,
	      GLT_ControlType control, GLT_AllocType alloc,
	      GLT_InitType init, GLT_CopyType copy, GLT_FreeType forget);

#endif
