/*  */
/* (c) 1993 by NEUROTEC GmbH 					         */
/* All rights reserved							 */
/*  */
/* Filename   : SELECT.C                                                 */
/* Author     : Sven Feddersen						 */
/* Project    : GenLib     						 */
/*  */
/*									 */
/* Publics :								 */
/*                                                                       */
/*   unsigned GaussSelection(POPULATION *pop);                           */
/*   unsigned InvRouletteSelection(POPULATION *pop);                     */
/*									 */
/*  */

#ifdef __TURBOC__
#include <math.h>
#include <stdlib.h>
#include <values.h>
#else
#include <math.h>
#include <stdlib.h>
#include <values.h>
#endif

#include <genlib.h>


#define CONST 0


static unsigned long GAUSS(unsigned long n) {
  return((n*n+n) / 2);
}


unsigned GaussSelection(POPULATION *pop) {
unsigned long start, rnd;
unsigned retl;


  start = GAUSS(CONST);
  rnd = EqualLongRandom(GAUSS(pop->size+CONST) - start) + start;
  retl = (sqrt((double)rnd*8+1)-1) / 2;
  return(pop->fitvec[retl]);
}


unsigned InvRouletteSelection(POPULATION *pop) {
unsigned result = 0;
double sum, rnd, memo;

  rnd = EqualDoubleRandom(pop->invfitsum);
  memo = pop->rep[pop->fitvec[0]].fitness - pop->rep[0].fitness;
  sum = max(memo, MINDOUBLE);
  while (sum < rnd) {
    memo = pop->rep[pop->fitvec[0]].fitness - pop->rep[++result].fitness;
    sum += max(memo, MINDOUBLE);
  }
  return(result);
}
