/* **********************************************************************************/
/* * file status is D: USER	 .C		  3722  05.10.93	12:34 							*/
/* * author is K. Kater 																				*/
/* * creation date was 26.06.91, last-modification on 05.10.93 							*/
/* **********************************************************************************/
/* * All parts of this program source and its documentation are							*/
/* * proprietary to its author(s) and are not to be disclosed to							*/
/* * others or used for purposes other than intended without his							*/
/* * written approval.																					*/
/* 																											*/
/* Copyright (1993) by																					*/
/* <NEUROTEC GmbH, 88046 Friedrichshafen	Ehlersstrae 15>									*/
/* **********************************************************************************/

#include "user.h"

/****************************************************************/
/* float fitness(int, double*, int):									 */
/****************************************************************/
/* Input:		 Nummer der aktuellen Generation 					 */
/* 				 Pointer auf den ersten bergebenen double-Wert  */
/* 				 Anzahl belegter double-Werte 						 */
/* Output:		 Fitness, die nach der Bewertungsfunktion des	 */
/* 				 Users den bergebenen double-Parametern ent-	 */
/* 				 spricht.													 */
/* Description: Wird vom User geschrieben und enthlt die voll- */
/* 				 stndige Bewertungsfunktion fr ein mit ge- 	 */
/* 				 netischen Methoden zu optimierendes Problem.	 */
/* 				 Vor dem ersten Aufruf dieser Funktion wird auf  */
/* 				 jeden Fall die ebenfalls vom User zu schreiben- */
/* 				 de Funktion fitness_start aufgerufen, um mitzu- */
/* 				 teilen, da die Evolution beginnt. 				 */
/* 				 Wird eine neue Population mit Anfangswerten 	 */
/* 				 initialisiert, wird die Funktion fitness_init	 */
/* 				 aufgerufen.												 */
/* 				 Am Ende einer Evolution, wird die Funktion		 */
/* 				 fitness_end aufgerufen.
/****************************************************************/
float fitness(int nGeneration, double *DoubleField, int cDouble)
{
	int i;
	double Sum;

	if (cDouble != 4)
		return 0.0;

	for (Sum=i = 0; i < 4; i++)
		Sum += *(DoubleField+i);

	return 1/(53-Sum);
}


/****************************************************************/
/* void fitness_end(double*, int):										 */
/****************************************************************/
/* Input:		 - 															 */
/* Output:		 - 															 */
/* Description: Wird vom Evolutions-Algorithmus nach Beendigung */
/* 				 eines Evolutionslaufes aufgerufen. 				 */
/****************************************************************/
void fitness_end(double* DoubleField, int cDouble)
{
	return;
}


/****************************************************************/
/* boolean fitness_init(int): 											 */
/****************************************************************/
/* Input:		 - 															 */
/* Output:		 - 															 */
/* Description: Wird vom Evolutions-Algorithmus vor dem Initia- */
/* 				 lisieren einer neuen Population aufgerufen. 	 */
/****************************************************************/
boolean fitness_init(int cDouble)
{
	return TRUE;
}


/****************************************************************/
/* boolean fitness_start(void):											 */
/****************************************************************/
/* Input:		 - 															 */
/* Output:		 - 															 */
/* Description: Wird vom Evolutions-Algorithmus vor dem Start	 */
/* 				 eines Evolutionslaufes aufgerufen. 				 */
/****************************************************************/
boolean fitness_start(void)
{
	return TRUE;
}


