/*  */
/* (c) 1991 by Expert Informatik 					 */
/* All rights reserved							 */
/*  */
/* Filename   : ORDER.H                                                  */
/* Author     : Sven Feddersen						 */
/* Project    : GenLib     						 */
/*  */
/*									 */
/* Comment :								 */
/*                                                                       */
/*   Include-Datei fr die Reihenfolge-Reprsentation                    */
/*									 */
/*  */


#ifndef _ORDER_H_
#define _ORDER_H_

#include <genlib.h>


typedef struct {
  unsigned n;
  unsigned *job;
} OrderRep;


void OrderCopy(CHROM *d, CHROM *s);
int OrderAlloc(unsigned popsize, POPULATION *pop);
int OrderRandInit(POPULATION *pop);
int OrderFree(POPULATION *pop);

int EdgeRecombination(CHROM *p1, CHROM *p2, CHROM *c);
int GoldbergPMX(CHROM *p1, CHROM *p2, CHROM *c);
int GoldbergOX(CHROM *p1, CHROM *p2, CHROM *c);
int GoldbergCX(CHROM *p1, CHROM *p2, CHROM *c);
int UniformOrderBased(CHROM *p1, CHROM *p2, CHROM *c);

int ConstantMoveMutation(CHROM *c);
int ConstantSwapMutation(CHROM *c);
int ConstantInvertMutation(CHROM *c);
int AdaptedMoveMutation(CHROM *c);
int AdaptedSwapMutation(CHROM *c);
int AdaptedInvertMutation(CHROM *c);

#endif